' Copyright 2003 Captator - de danske .NET eksperter
' Denne kode er til fri afbenyttelse.
' Denne kode er lavet som et eksempel i forbindelse med artiklen "Typestrke collections".
' Har du ikke artiklen, kan du finde den p www.captator.dk
' Finder du en fejl s lad vre med at sagsge os ;^)
' Fortl os i stedet for om fejl og forslag til forbedringer p f.eks. e-mail: lykke@captator.dk 

Public Class FormCollection
  Implements System.Collections.IList

  Private _collection As New System.Collections.ArrayList()

  Public Sub Add(ByVal frm As System.Windows.Forms.Form)
    _collection.Add(frm)
  End Sub

  Public Function Contains(ByVal frm As System.Windows.Forms.Form) As Boolean
    Return _collection.Contains(frm)
  End Function

  Public Sub Clear()
    _collection.Clear()
  End Sub

  Public ReadOnly Property Count() As Integer
    Get
      Return _collection.Count
    End Get
  End Property

  Public Sub Insert(ByVal index As Integer, ByVal frm As System.Windows.Forms.Form)
    _collection.Insert(index, frm)
  End Sub

  Default Public Property Item(ByVal index As Integer) As System.Windows.Forms.Form
    Get
      Return CType(_collection.Item(index), System.Windows.Forms.Form)
    End Get
    Set(ByVal Value As System.Windows.Forms.Form)
      _collection.Item(index) = Value
    End Set
  End Property

  Public Sub Remove(ByVal frm As System.Windows.Forms.Form)
    _collection.Remove(frm)
  End Sub

  Public Sub RemoveAt(ByVal index As Integer)
    _collection.RemoveAt(index)
  End Sub

  Private Function IList_Add(ByVal value As Object) As Integer Implements System.Collections.IList.Add
    Me.Add(CType(value, System.Windows.Forms.Form))
  End Function

  Private Sub IList_Clear() Implements System.Collections.IList.Clear
    Me.Clear()
  End Sub

  Private Function IList_Contains(ByVal value As Object) As Boolean Implements System.Collections.IList.Contains
    Me.Contains(CType(value, System.Windows.Forms.Form))
  End Function

  Private Sub IList_CopyTo(ByVal array As System.Array, ByVal index As Integer) Implements System.Collections.IList.CopyTo
    _collection.CopyTo(array, index)
  End Sub

  Private ReadOnly Property IList_Count() As Integer Implements System.Collections.IList.Count
    Get
      Return Me.Count()
    End Get
  End Property

  Private Function IList_GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.IList.GetEnumerator

    Return New FormCollectionEnumerator(Me)

    'Ovenstende linje laver et implicit typecast til IEnumerator.
    'Linjen kunne  ogs skrives som f.eks.:
    'Return CType(New FormCollectionEnumerator(Me), IEnumerator)

  End Function

  Private Function IList_IndexOf(ByVal value As Object) As Integer Implements System.Collections.IList.IndexOf
    Return _collection.IndexOf(value)
  End Function

  Private Sub IList_Insert(ByVal index As Integer, ByVal value As Object) Implements System.Collections.IList.Insert
    Me.Insert(index, CType(value, System.Windows.Forms.Form))
  End Sub

  Private ReadOnly Property IList_IsFixedSize() As Boolean Implements System.Collections.IList.IsFixedSize
    Get
      Return _collection.IsFixedSize()
    End Get
  End Property

  Private ReadOnly Property IList_IsReadOnly() As Boolean Implements System.Collections.IList.IsReadOnly
    Get
      Return _collection.IsReadOnly()
    End Get
  End Property

  Private ReadOnly Property IList_IsSynchronized() As Boolean Implements System.Collections.IList.IsSynchronized
    Get
      Return True
    End Get
  End Property

  Private Property IList_Item(ByVal index As Integer) As Object Implements System.Collections.IList.Item
    Get
      Return Me.Item(index)
    End Get
    Set(ByVal Value As Object)
      Me.Item(index) = CType(Value, System.Windows.Forms.Form)
    End Set
  End Property

  Private Sub IList_Remove(ByVal value As Object) Implements System.Collections.IList.Remove
    Me.Remove(CType(value, System.Windows.Forms.Form))
  End Sub

  Private Sub IList_RemoveAt(ByVal index As Integer) Implements System.Collections.IList.RemoveAt
    Me.RemoveAt(index)
  End Sub

  Private ReadOnly Property IList_SyncRoot() As Object Implements System.Collections.IList.SyncRoot
    Get
      Return _collection.SyncRoot
    End Get
  End Property

  Private Class FormCollectionEnumerator
    Implements System.Collections.IEnumerator

    Private _index As Integer = -1
    Private _forms As FormCollection

    Public Sub New(ByVal forms As FormCollection)
      _forms = forms
    End Sub

    Private ReadOnly Property Current() As Object Implements System.Collections.IEnumerator.Current
      Get
        Return _forms(_index)
      End Get
    End Property

    Private Function MoveNext() As Boolean Implements System.Collections.IEnumerator.MoveNext

      _index += 1

      If _index < _forms.Count Then
        Return True
      Else
        Return False
      End If

    End Function

    Private Sub Reset() Implements System.Collections.IEnumerator.Reset
      _index = -1
    End Sub

  End Class

End Class
